package edu.stanford.db.rdf.model.i;

import org.w3c.rdf.model.*;
import com.lastmileservices.rdf.util.*;

public abstract class RDFNodeImpl implements RDFNode, LongIDAware {

  protected int nodeID;
  private int _hashCode;

  protected RDFNodeImpl(int nodeID) {

    this.nodeID = nodeID;
  }

  protected RDFNodeImpl() {
  }

  public String	toString () {
    return getLabel();
  }

  public abstract String getLabel();

  public long getLongID() {

    return nodeID;
  }

  public int hashCode() {

     if(_hashCode == 0)
       _hashCode = getLabel().hashCode();

     return _hashCode;
  }

  /** That's the beauty of it... */
  public boolean equals(Object that) 
  {
    return this == that;
  }
  
}
